/* $EPIC:$ */
/*
 * network.h -- stuff that handles internet connections, hostname lookups,
 * and other generic socket operations.
 *
 * Copyright  1999 Jeremy Nelson
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notices, the above paragraph (the one permitting redistribution),
 *    this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution.
 * 3. The names of the author(s) may not be used to endorse or promote 
 *    products derived from this software without specific prior written
 *    permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE.
 */

/* Possible "service" values */
#define	SERVICE_SERVER		0
#define	SERVICE_CLIENT		1
#define SERVICE_NONBLOCK	2

/* Possible "protocol" values */
#define PROTOCOL_TCP		0
#define PROTOCOL_UDP		1


	int	connect_by_number	(char *host, unsigned short *port, 
					 int service, int protocol,
					 int (*callback) (int, int, char *));

	Host *	inet_ntoh		(IA);
	IA *	inet_hton		(const Host *);
	Host *	inet_hntoh		(Char *);
	Char *	inet_htohn		(const Host *);
	Host *	inet_atoh		(Char *);
	Char *	inet_htoa		(const Host *);
	Host *	inet_anytoh		(Char *);
	Char *	inet_hntoa		(Char *);
	Char *	inet_atohn		(Char *);
	Char *	inet_ntoany		(IA);
	IA 	inet_anyton		(Char *);
	Char *	inet_anytoother		(Char *);

	int	set_non_blocking	(int);
	int	set_blocking		(int);
	int	my_accept		(int, SA *, int *);
	void	set_socket_options	(int);


