/* $EPIC:$ */
/*
 * newio2.h -- header file for the new newio2.c stuff.
 * Written by Jeremy Nelson
 * Copyright 1999 EPIC Software labs
 */

#ifndef __newio2_h__
#define __newio2_h__

#define IO_BUFFER_SIZE	8192

typedef	int			(*Reader)	(int, int, char *);
typedef int			(*Writer)	(int, int, char *);
typedef int			(*Eof)		(int);
typedef int			(*Error)	(int);

struct discipline_u {
	Reader			reader;
	Writer			writer;
	Eof			eof;
	Error			error;
};
typedef struct discipline_u	Discipline;

	void	do_events		(int utimeout);
	void	set_up_newio		(void);
	int	line_buffering		(int, Discipline *);
	int	no_buffering		(int, Discipline *);
	int	no_buffering_readonly 	(int, Discipline *);
	int	exec_buffering		(int, Discipline *);
	int	nonblocking_connect_callback (int, Writer);
	int	accept_callback		(int, Reader);
	int	new_close		(int);

extern	int	io_errno;

#endif	/* __newio2_h__ */
