/* $EPIC:$ */
/*
 * nutty.h: header file for nutty.c
 *
 * Copyright  2000 Jeremy Nelson and others ("EPIC Software Labs").
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notices, the above paragraph (the one permitting redistribution),
 *    this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution.
 * 3. The names of the author(s) may not be used to endorse or promote 
 *    products derived from this software without specific prior written
 *    permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE.
 */

#ifndef __nutty_h__
#define __nutty_h__

	typedef struct	output_info_type {
		Winref		winref;
		Servref		servref;
		Char *		who_from;
		int		who_level;
	} output_info;

	typedef void (*output_callback) (const output_info *, const u_char *);

	/* These are low level routines, with no filter control whatsoever */
	int	register_output_callback	(output_callback);
	int	unregister_output_callback	(output_callback);
	void	do_output_callbacks 		(Winref, Servref, Char *, 
					 	 int, const u_char *);

	/* These are higher level routines, providing basic filter control */
	int	call_when_window_output	(output_callback, Winref);
	int	call_when_server_output	(output_callback, Servref);
	int	call_when_target_output	(output_callback, Char *);
	int	call_when_level_output	(output_callback, int);
	int	call_when_this_output	(output_callback, output_info *);
	int	call_when_any_output	(output_callback, output_info *ign);
	void	cancel_callback		(int);

#endif
